{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module Nat where {


data Nat = Suc Nat | Zero_nat deriving (Read, Show);

option_case :: forall t a. t -> (a -> t) -> Maybe a -> t;
option_case f1 f2 Nothing = f1;
option_case f1 f2 (Just a) = f2 a;

nat_case :: forall t. t -> (Nat -> t) -> Nat -> t;
nat_case f1 f2 Zero_nat = f1;
nat_case f1 f2 (Suc nat) = f2 nat;

eq_nat :: Nat -> Nat -> Bool;
eq_nat Zero_nat Zero_nat = True;
eq_nat (Suc m) (Suc n) = eq_nat m n;
eq_nat Zero_nat (Suc a) = False;
eq_nat (Suc a) Zero_nat = False;

one_nat :: Nat;
one_nat = Suc Zero_nat;

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat (Suc m) n = less_nat m n;
less_eq_nat Zero_nat n = True;

less_nat :: Nat -> Nat -> Bool;
less_nat m (Suc n) = less_eq_nat m n;
less_nat n Zero_nat = False;

plus_nat :: Nat -> Nat -> Nat;
plus_nat (Suc m) n = plus_nat m (Suc n);
plus_nat Zero_nat n = n;

times_nat :: Nat -> Nat -> Nat;
times_nat (Suc m) n = plus_nat n (times_nat m n);
times_nat Zero_nat n = Zero_nat;

}
