{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module Show where {

import qualified List;
import qualified Nat;

class Sshow a where {
  sshow :: a -> [Char];
};

sshowa :: forall c d. (Show.Sshow c, Show.Sshow d) => (c, d) -> [Char];
sshowa (x, y) = List.concata [Show.sshow x, " -> ", Show.sshow y];

instance (Show.Sshow a, Show.Sshow b) => Show.Sshow (a, b) where {
  sshow = Show.sshowa;
};

sEmpty :: [Char];
sEmpty = [];

showLista :: [[Char]] -> [Char];
showLista xs = List.concata (List.mapa (\ x -> List.append x "\n") xs);

sshow_char :: Char -> [Char];
sshow_char x = [x];

instance Show.Sshow Char where {
  sshow = Show.sshow_char;
};

int_to_abs :: Integer -> Nat.Nat;
int_to_abs i =
  (if i <= 0 then Nat.Zero_nat else Nat.Suc (Show.int_to_abs (i - 1)));

sshow_nat :: Nat.Nat -> [Char];
sshow_nat (Nat.Suc n) = List.append (List.append "S(" (Show.sshow_nat n)) ")";
sshow_nat Nat.Zero_nat = "0";

sshow_int :: Integer -> [Char];
sshow_int i =
  (if 0 <= i then Show.sshow_nat (Show.int_to_abs i)
    else List.append "-" (Show.sshow_nat (Show.int_to_abs (0 - i))));

sshow_list :: forall a. (Show.Sshow a) => [a] -> [Char];
sshow_list xs = List.concata (List.mapa Show.sshow xs);

instance (Show.Sshow a) => Show.Sshow [a] where {
  sshow = Show.sshow_list;
};

}
