{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module Trs where {

import qualified Term;
import qualified List;
import qualified Show;

data Shp a = Plain a | Sharp a deriving (Read, Show);

eq_shp :: forall f. (Eq f) => Trs.Shp f -> Trs.Shp f -> Bool;
eq_shp (Trs.Sharp f) (Trs.Sharp f') = f == f';
eq_shp (Trs.Plain f) (Trs.Plain f') = f == f';
eq_shp (Trs.Sharp a) (Trs.Plain b) = False;
eq_shp (Trs.Plain b) (Trs.Sharp a) = False;

instance (Eq a) => Eq (Trs.Shp a) where {
  (==) = Trs.eq_shp;
};

showRule ::
  forall a b.
    (Show.Sshow a, Show.Sshow b) => (Term.Term a b, Term.Term a b) -> [Char];
showRule (l, r) =
  List.append (List.append (Term.sshow_term l) " -> ") (Term.sshow_term r);

showRules ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] -> [[Char]];
showRules r = List.mapa Trs.showRule r;

showP ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] -> [[Char]];
showP p = "dependency pairs: " : List.append (Trs.showRules p) [[]];

plaina :: forall a b. Term.Term a b -> Term.Term (Trs.Shp a) b;
plaina (Term.Fun f ss) = Term.Fun (Trs.Plain f) (List.mapa Trs.plaina ss);
plaina (Term.Var x) = Term.Var x;

sharpa :: forall a b. Term.Term a b -> Term.Term (Trs.Shp a) b;
sharpa (Term.Fun f ss) = Term.Fun (Trs.Sharp f) (List.mapa Trs.plaina ss);
sharpa (Term.Var x) = Term.Var x;

showDPP ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] ->
                         [(Term.Term a b, Term.Term a b)] -> [[Char]];
showDPP p r =
  "dependency pairs: " :
    List.append (Trs.showRules p)
      ([] : "rewrite system:" : List.append (Trs.showRules r) [[]]);

showTRS ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => [(Term.Term a b, Term.Term a b)] -> [[Char]];
showTRS r = List.append (Trs.showRules r) [[]];

sshow_shp :: forall b. (Show.Sshow b) => Trs.Shp b -> [Char];
sshow_shp (Trs.Plain s) = Show.sshow s;
sshow_shp (Trs.Sharp s) = List.append (Show.sshow s) "#";

instance (Show.Sshow a) => Show.Sshow (Trs.Shp a) where {
  sshow = Trs.sshow_shp;
};

}
